/**
 * Start point for SwissTM include file. Make will create final include
 * file with all preprocessor directives defined.
 * 
 * @author Aleksandar Dragojevic
 */

#include "../src/stm/swisstm.h"
#include "../src/stm/tx_ptr.h"

//////////////////
// start/end tx //
//////////////////

#define BEGIN_TRANSACTION           \
	while(true) {                   \
		try {                       \
			swisstm::start_tx();    \

// body goes in the middle

#define END_TRANSACTION                       \
			swisstm::commit_tx();             \
			break;                            \
		} catch (swisstm::AbortedException) { \
			swisstm::abort_tx();              \
        } catch (...) {                       \
            swisstm::abort_tx();              \
            throw;                            \
        }                                     \
    }


////////////////////////////////////////////
// start/end transaction and count aborts //
////////////////////////////////////////////

#define BEGIN_TRANSACTION_CA        \
	while(true) {                   \
		try {                       \
			swisstm::start_tx();    \

// body goes in the middle

#define END_TRANSACTION_CA                    \
			swisstm::commit_tx();             \
			break;                            \
		} catch (swisstm::AbortedException) { \
			aborts++;                         \
			swisstm::abort_tx();              \
        } catch (...) {                       \
        	aborts++;                         \
            swisstm::abort_tx();              \
            throw;                            \
        }                                     \
    }
