/**
 * Some functions to make it simpler to access words containing both
 * version and lock bit.
 * 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#ifndef SWISSTM_VERSION_LOCK_H_
#define SWISSTM_VERSION_LOCK_H_

#define LSB 1u

namespace swisstm {

	typedef void *VersionLock;

	inline bool is_locked(VersionLock lock) {
		return (unsigned)lock & LSB;
	}

	inline unsigned get_value(VersionLock lock) {
		return (unsigned)lock >> 2;
	}

	inline VersionLock get_version_lock(unsigned ts) {
		return (VersionLock)(ts << 2);
	}

	inline VersionLock get_locked(void *thread) {
		return (VersionLock)((unsigned)thread | LSB);
	}

	inline void *get_owner(VersionLock lock) {
		return (void *)((unsigned)lock & ~LSB);
	}
}

#endif // SWISSTM_VERSION_LOCK_H_
