/**
 * Declaration of public interface of SwissTM.
 * 
 * Including this file and appropriately linking should be the only
 * prerequisite for using "basic" swisstm. Nicer API can be used if
 * appropriate API layer is included as well.
 * 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#ifndef SWISSTM_SWISSTM_H_
#define SWISSTM_SWISSTM_H_

#include "tid.h"
#include "memory.h"
#include "transaction.h"
#include "object.h"
#include "constants.h"
#include "common/time.h"

namespace swisstm {

	void global_init();

	void thread_init();

	void start_tx();

	void start_tx_nested();

	void commit_tx();

	void commit_tx_nested();

	void abort_tx();

	void abort_tx_full();

	void abort_tx_nested();
}

#endif // SWISSTM_SWISSTM_H_
